use Language::INTERCAL;
use Language::INTERCAL::Runtime::Library;

my $prog = '
@@@@@@@@K@L`@{
@@@@@@@@K@L`@{
@@@@@@@@K@L`@{
@@@@@@@@K@L`@{[|J{{J{
@@@@@@@@@@K
@@@@@@@@@@K
@@@@@@@@@@K
@@@@@@@@@@K
@@@@@@@@K@L`@{KJKKJK
@@@@@@@@@@K
@@@@@@@@@@K
@@@@@@@@@@K
@@@@@@@@@@K
@@@@@@@@@@K
@@@@@@@@@@K
@@@@@@@@K@L`@{[|
@@@@@@@@@@K
@@@@@@@@K@L`@KaPK
@@@@@@@@@@K
@@@@@@@@K@L`@KaK
@@@@@@@@@@K
@@@@@@@@K@L`@KaeK
@@@@@@@@@@K
@@@@@@@@K@L`@{KJ{{J{
@@@@@@@@@
';

print "1..96\n";

fiddle Language::INTERCAL 'bug=0', 'ubug=0';

my @foo;

compile Language::INTERCAL 'prog', $prog;
@foo= ();
eval { prog(0, \&foo) };
print $@ if $@ !~ /275 ASSIGNMENT TO CONSTANT/;
print $@ =~ /275 ASSIGNMENT TO CONSTANT/ ? "" : "not ", "ok 1\n";
print @foo == 14 ? "" : "not ", "ok 2\n";
print shift @foo eq "LII\n" ? "" : "not ", "ok 3\n";
print shift @foo eq "XIV\n" ? "" : "not ", "ok 4\n";
print shift @foo eq "X\n" ? "" : "not ", "ok 5\n";
print shift @foo eq "XXXII\n" ? "" : "not ", "ok 6\n";
print shift @foo eq "XXII\n" ? "" : "not ", "ok 7\n";
print shift @foo eq "VI\n" ? "" : "not ", "ok 8\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 9\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 10\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 11\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 12\n";
print shift @foo eq "XXX\n" ? "" : "not ", "ok 13\n";
print shift @foo eq "LXII\n" ? "" : "not ", "ok 14\n";
print shift @foo eq "XXVIII\n" ? "" : "not ", "ok 15\n";
print shift @foo eq "XX\n" ? "" : "not ", "ok 16\n";

compile Language::INTERCAL 'prog_o', $prog, 'opt';
@foo= ();
eval { prog_o(0, \&foo) };
print $@ if $@ !~ /275 ASSIGNMENT TO CONSTANT/;
print $@ =~ /275 ASSIGNMENT TO CONSTANT/ ? "" : "not ", "ok 17\n";
print @foo == 14 ? "" : "not ", "ok 18\n";
print shift @foo eq "LII\n" ? "" : "not ", "ok 19\n";
print shift @foo eq "XIV\n" ? "" : "not ", "ok 20\n";
print shift @foo eq "X\n" ? "" : "not ", "ok 21\n";
print shift @foo eq "XXXII\n" ? "" : "not ", "ok 22\n";
print shift @foo eq "XXII\n" ? "" : "not ", "ok 23\n";
print shift @foo eq "VI\n" ? "" : "not ", "ok 24\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 25\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 26\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 27\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 28\n";
print shift @foo eq "XXX\n" ? "" : "not ", "ok 29\n";
print shift @foo eq "LXII\n" ? "" : "not ", "ok 30\n";
print shift @foo eq "XXVIII\n" ? "" : "not ", "ok 31\n";
print shift @foo eq "XX\n" ? "" : "not ", "ok 32\n";

compile Language::INTERCAL 'prog_q', $prog, 'quantum';
@foo= ();
eval { prog_q(0, \&foo) };
print $@ if $@ !~ /275 ASSIGNMENT TO CONSTANT/;
print $@ =~ /275 ASSIGNMENT TO CONSTANT/ ? "" : "not ", "ok 33\n";
print @foo == 14 ? "" : "not ", "ok 34\n";
print shift @foo eq "LII\n" ? "" : "not ", "ok 35\n";
print shift @foo eq "XIV\n" ? "" : "not ", "ok 36\n";
print shift @foo eq "X\n" ? "" : "not ", "ok 37\n";
print shift @foo eq "XXXII\n" ? "" : "not ", "ok 38\n";
print shift @foo eq "XXII\n" ? "" : "not ", "ok 39\n";
print shift @foo eq "VI\n" ? "" : "not ", "ok 40\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 41\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 42\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 43\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 44\n";
print shift @foo eq "XXX\n" ? "" : "not ", "ok 45\n";
print shift @foo eq "LXII\n" ? "" : "not ", "ok 46\n";
print shift @foo eq "XXVIII\n" ? "" : "not ", "ok 47\n";
print shift @foo eq "XX\n" ? "" : "not ", "ok 48\n";

compile Language::INTERCAL 'prog_p', $prog, 'post';
@foo= ();
eval { prog_p(0, \&foo) };
print $@ if $@ !~ /275 ASSIGNMENT TO CONSTANT/;
print $@ =~ /275 ASSIGNMENT TO CONSTANT/ ? "" : "not ", "ok 49\n";
print @foo == 14 ? "" : "not ", "ok 50\n";
print shift @foo eq "LII\n" ? "" : "not ", "ok 51\n";
print shift @foo eq "XIV\n" ? "" : "not ", "ok 52\n";
print shift @foo eq "X\n" ? "" : "not ", "ok 53\n";
print shift @foo eq "XXXII\n" ? "" : "not ", "ok 54\n";
print shift @foo eq "XXII\n" ? "" : "not ", "ok 55\n";
print shift @foo eq "VI\n" ? "" : "not ", "ok 56\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 57\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 58\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 59\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 60\n";
print shift @foo eq "XXX\n" ? "" : "not ", "ok 61\n";
print shift @foo eq "LXII\n" ? "" : "not ", "ok 62\n";
print shift @foo eq "XXVIII\n" ? "" : "not ", "ok 63\n";
print shift @foo eq "XX\n" ? "" : "not ", "ok 64\n";

compile Language::INTERCAL 'prog_qp', $prog, 'quantum', 'post';
@foo= ();
eval { prog_qp(0, \&foo) };
print $@ if $@ !~ /275 ASSIGNMENT TO CONSTANT/;
print $@ =~ /275 ASSIGNMENT TO CONSTANT/ ? "" : "not ", "ok 65\n";
print @foo == 14 ? "" : "not ", "ok 66\n";
print shift @foo eq "LII\n" ? "" : "not ", "ok 67\n";
print shift @foo eq "XIV\n" ? "" : "not ", "ok 68\n";
print shift @foo eq "X\n" ? "" : "not ", "ok 69\n";
print shift @foo eq "XXXII\n" ? "" : "not ", "ok 70\n";
print shift @foo eq "XXII\n" ? "" : "not ", "ok 71\n";
print shift @foo eq "VI\n" ? "" : "not ", "ok 72\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 73\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 74\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 75\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 76\n";
print shift @foo eq "XXX\n" ? "" : "not ", "ok 77\n";
print shift @foo eq "LXII\n" ? "" : "not ", "ok 78\n";
print shift @foo eq "XXVIII\n" ? "" : "not ", "ok 79\n";
print shift @foo eq "XX\n" ? "" : "not ", "ok 80\n";

compile Language::INTERCAL 'prog_d', $prog, 'dbhook';
@foo= ();
_run_db(prog_d(0, \&foo));
print $@ if $@ !~ /275 ASSIGNMENT TO CONSTANT/;
print $@ =~ /275 ASSIGNMENT TO CONSTANT/ ? "" : "not ", "ok 81\n";
print @foo == 14 ? "" : "not ", "ok 82\n";
print shift @foo eq "LII\n" ? "" : "not ", "ok 83\n";
print shift @foo eq "XIV\n" ? "" : "not ", "ok 84\n";
print shift @foo eq "X\n" ? "" : "not ", "ok 85\n";
print shift @foo eq "XXXII\n" ? "" : "not ", "ok 86\n";
print shift @foo eq "XXII\n" ? "" : "not ", "ok 87\n";
print shift @foo eq "VI\n" ? "" : "not ", "ok 88\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 89\n";
print shift @foo eq "CCLV\n" ? "" : "not ", "ok 90\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 91\n";
print shift @foo eq "DLXXII\n" ? "" : "not ", "ok 92\n";
print shift @foo eq "XXX\n" ? "" : "not ", "ok 93\n";
print shift @foo eq "LXII\n" ? "" : "not ", "ok 94\n";
print shift @foo eq "XXVIII\n" ? "" : "not ", "ok 95\n";
print shift @foo eq "XX\n" ? "" : "not ", "ok 96\n";

sub foo {
    push @foo, join('', @_);
}

